#ifndef __PATROL__1692__
#define __PATROL__1692__

#define __MAXE__ 100010
#define __MAXV__ 1010

#include <cstdio>
#include <cstdlib>

void Init();
void GetVE(int&, int&);
void Get(int&, int&);
void ReportVst(int);
void ReportVed(int);
void ReportE(int);
void Final();

namespace myname {
	int V, E, ei;
	int edge[2][__MAXE__];
}

void Init() {
    printf("Init().\n");
	scanf("%d%d", &myname::V, &myname::E);
	for(int i=1; i<=myname::E; i++)
		scanf("%d%d", &myname::edge[0][i], &myname::edge[1][i]);
}

void GetVE(int&v, int&e) {
    printf("GetVE().\n");
	myname::ei = 1;
	v = myname::V;
	e = myname::E;
}

void Get(int&e1, int&e2) {
    printf("Get() #%d.\n", myname::ei);
	e1 = myname::edge[0][myname::ei];
	e2 = myname::edge[1][myname::ei];
	myname::ei ++;
}

void ReportVst(int no) {
    printf("Start at Room %d.\n", no);
}

void ReportVed(int no) {
	printf("End at Room %d.\n", no);
}

void ReportE(int no) {
	printf("Visit Path %d (%d <-> %d)\n", no, myname::edge[0][no], myname::edge[1][no]);
}

void Final() {
	printf("Final().\n");
}
#endif
